//
//  WTSegmentView.m
//  HXMySegementView
//
//  Created by HXMAC on 2017/4/10.
//  Copyright © 2017年 HXMAC. All rights reserved.
//

#import "WTSegmentView.h"
#import "Header.h"
#import "HXPhotoButton.h"
#define borderW 0.5

@interface WTSegmentView()<HXPhotoButtonDelegate,UITableViewDelegate,UITableViewDataSource>
{
    UIButton *_selectedBtn;
    HXPhotoButton *_selectedPhotoBtn;
    NSMutableArray *_photoDataArray;//有图片的segment存储
    NSMutableArray *_listPhotoArray;//有菜单的segment存储
    NSArray *_numArray;//有菜单时，显示的列表
    NSArray *allArray;//存储传值的标题数组
    UITableView *_myTableView;//有菜单的列表展示
}
@end

@implementation WTSegmentView

/*
// Only override drawRect: if you perform custom drawing.
// An empty implementation adversely affects performance during animation.
- (void)drawRect:(CGRect)rect {
    // Drawing code
}
*/

- (id)initViewWithTitle:(NSArray *)titleArray andRect:(CGRect)rect andType:(HXChooseButtonType)type{
    self = [super initWithFrame:rect];
    _photoDataArray = [NSMutableArray array];
    
    if (self) {
        //1.只有按钮，无图片，无下拉菜单的选择／*这种选择多用到的地方是切换界面*／
        if (type == HXNoPhotoNoList) {
            for ( int i = 0; i < titleArray.count; i ++) {
                UIButton *segButton = [UIButton buttonWithType:UIButtonTypeCustom];
                segButton.frame = CGRectMake((rect.size.width - (titleArray.count * borderW))/3 * i, 0, rect.size.width         / 3 - (titleArray.count * borderW), rect.size.height);
                if (i != 0) {
                    UILabel *line = [[UILabel alloc]initWithFrame:CGRectMake((borderW + ViewFrame_W(segButton)) * i , 0, borderW, rect.size.height)];
                    line.backgroundColor = [UIColor grayColor];
                    [self addSubview:line];
                }
                segButton.tag = 100+i;//这里根据自己界面情况设定
                segButton.backgroundColor = [UIColor whiteColor];//在这里就不打算改变按钮点击的背景色。如果想改的话和字体颜色改变一样
                [segButton setTitle:[titleArray objectAtIndex:i] forState:UIControlStateNormal];
                [segButton setTitleColor:[UIColor grayColor] forState:UIControlStateNormal];
                [segButton setTitleColor:LightBlueColor forState:UIControlStateSelected];
                [segButton addTarget:self action:@selector(chooseSegment:) forControlEvents:UIControlEventTouchUpInside];
                [self addSubview:segButton];
                if (i == 0) {
                    segButton.selected = YES;
                    _selectedBtn = segButton;
                }
            }
        }
        if (type == HXNoList) {
            for ( int i = 0; i < titleArray.count; i ++) {
                HXPhotoButton *segButton = [[HXPhotoButton alloc] initWithTitle:[titleArray objectAtIndex:i] andFrame:CGRectMake((rect.size.width - (titleArray.count * borderW))/3 * i, 0, (rect.size.width - (titleArray.count * borderW))/3, rect.size.height) angTag:(200 + i)];
                if (i != 0) {
                UILabel *line = [[UILabel alloc]initWithFrame:CGRectMake((borderW + ViewFrame_W(segButton)) * i , 0, borderW, rect.size.height)];
                    line.backgroundColor = [UIColor grayColor];
                    [self addSubview:line];
                }
                segButton.photoButtonDelegate = self;
                //默认开始时的选择条件状态
                if (i == 0) {
                    segButton.myBtn.selected = YES;
                    segButton.upBtn.selected = NO;
                    segButton.downBtn.selected = YES;
                    _selectedPhotoBtn = segButton;
                    [_photoDataArray addObject:@{@"typekey":[titleArray objectAtIndex:0],@"phototype":[NSNumber numberWithInteger:HXDOWTYPE]}];//存储所选按钮和查找类型键值对
                }else
                    [_photoDataArray addObject:@{@"typekey":[titleArray objectAtIndex:i],@"phototype":[NSNumber numberWithInteger:HXNONETYPE]}];
                segButton.tag = 200+i;
                [segButton.myBtn bringSubviewToFront:segButton];
                [self addSubview:segButton];
            }
        }
        if (type == HXNOPHOTO) {
            _listPhotoArray = [NSMutableArray array];
            //因为标题的按钮数量不明，如果是多项，则用系统自带button处理，并且多处一个菜单。如果只有单个，并且包含顺序的话用hxphotobutton初始化
            for (int i = 0; i < titleArray.count; i ++) {
                NSArray *detailArray = [titleArray objectAtIndex:i];
                allArray = titleArray;
                if (detailArray.count > 1) {
                    UIButton *button = [UIButton buttonWithType:UIButtonTypeCustom];
                    button.frame = CGRectMake((rect.size.width - (titleArray.count * borderW))/3 * i, 0, rect.size.width / 3 - (titleArray.count * borderW), rect.size.height);
                    [button setTitle:[detailArray objectAtIndex:0] forState:UIControlStateNormal];
                    button.tag = 300+i;//这里根据自己界面情况设定
                    button.backgroundColor = [UIColor whiteColor];//在这里就不打算改变按钮点击的背景色。如果想改的话和字体颜色改变一样
                    [button setTitleColor:[UIColor grayColor] forState:UIControlStateNormal];
//                    [button setTitleColor:LightBlueColor forState:UIControlStateSelected];
                    [button addTarget:self action:@selector(chooseListButton:) forControlEvents:UIControlEventTouchUpInside];
                    [self addSubview:button];
                    [_listPhotoArray addObject:@{@"typekey":[detailArray objectAtIndex:0],@"phototype":[NSNumber numberWithInteger:HXNONETYPE]}];//存储所选按钮和查找类型键值对
                }
                else{
                    HXPhotoButton *segButton = [[HXPhotoButton alloc] initWithTitle:[detailArray objectAtIndex:0] andFrame:CGRectMake((rect.size.width - (titleArray.count * borderW))/3 * i, 0, (rect.size.width - (titleArray.count * borderW))/3, rect.size.height) angTag:(300 + i)];
                    segButton.myBtn.selected = YES;
                    segButton.upBtn.selected = NO;
                    segButton.downBtn.selected = YES;
                    [segButton.myBtn addTarget:self action:@selector(chooseListButton:) forControlEvents:UIControlEventTouchUpInside];
                    [_listPhotoArray addObject:@{@"typekey":[detailArray objectAtIndex:0],@"phototype":[NSNumber numberWithInteger:HXDOWTYPE]}];//存储所选按钮和查找类型键值对
                    segButton.tag = 300+i;
                    _selectedPhotoBtn  = segButton;
                    [self addSubview:segButton];
                }
                if (i != 0) {
                    UILabel *line = [[UILabel alloc]initWithFrame:CGRectMake((borderW + rect.size.width         / 3 - (titleArray.count * borderW)) * i , 0, borderW, rect.size.height)];
                    line.backgroundColor = [UIColor grayColor];
                    [self addSubview:line];
                }
            }
        }
        self.layer.borderWidth = borderW;
        self.layer.borderColor = [UIColor grayColor].CGColor;

    }
    return self;
}
- (void)createListUI:(NSArray *)detailArr{
    _numArray = detailArr;
    if (!_myTableView) {
        _myTableView = [[UITableView alloc]initWithFrame:CGRectZero style:UITableViewStylePlain];
        _myTableView.scrollEnabled = NO;
        _myTableView.delegate = self;
        _myTableView.dataSource = self;
        [self.superview addSubview:_myTableView];
        [_myTableView bringSubviewToFront:self.superview];
    }else{
        _myTableView.hidden = NO;
        [_myTableView reloadData];
    }
    _myTableView.frame = CGRectMake(0, ViewFrameY_H(self), ViewFrame_W(self), 44* detailArr.count);
    _myTableView.tableFooterView = [[UIView alloc]initWithFrame:CGRectZero];

}
- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section{
    return _numArray.count;
}
- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath{
    return 44;
}
- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath{
    static NSString *cellIde = @"cellIde";
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:cellIde];
    if (!cell) {
        cell = [[UITableViewCell alloc]initWithStyle:UITableViewCellStyleDefault reuseIdentifier:cellIde];
    }
    cell.textLabel.text = [_numArray objectAtIndex:indexPath.row];
    return cell;
}
- (void)chooseListButton:(UIButton *)button{
    UIView *view = button.superview;
    if ([view isKindOfClass:[self class]]) {
        UIButton *btn = (UIButton *)button;
        
        [self createListUI:[allArray objectAtIndex:btn.tag - 300]];
        _selectedBtn = btn;
    }else if ([view isKindOfClass:[HXPhotoButton class]]){
        HXPhotoButton *photoBtn = (HXPhotoButton *)view;
        if (photoBtn.tag == _selectedPhotoBtn.tag) {
            photoBtn.myBtn.selected = YES;
            photoBtn.upBtn.selected = !_selectedPhotoBtn.upBtn.selected;
            photoBtn.downBtn.selected = !_selectedPhotoBtn.downBtn.selected;
            _selectedPhotoBtn = photoBtn;
        }else{
            [_listPhotoArray replaceObjectAtIndex:(_selectedPhotoBtn.tag - 300) withObject:@{@"typekey":[NSString stringWithFormat:@"%@",_selectedPhotoBtn.myBtn.titleLabel.text],@"phototype":[NSNumber numberWithInteger:HXNONETYPE]}];
            
            photoBtn.myBtn.selected = YES;
            if (!photoBtn.upBtn.selected && !photoBtn.downBtn.selected) {
                photoBtn.upBtn.selected = NO;
                photoBtn.downBtn.selected = YES;
            }else{
                photoBtn.upBtn.selected = !photoBtn.upBtn.selected;
                photoBtn.downBtn.selected =!photoBtn.downBtn.selected;
            }
            _selectedPhotoBtn = photoBtn;
        }
        [_listPhotoArray replaceObjectAtIndex:(_selectedPhotoBtn.tag - 300) withObject:@{@"typekey":[NSString stringWithFormat:@"%@",_selectedPhotoBtn.myBtn.titleLabel.text],@"phototype":[NSNumber numberWithInteger:_selectedPhotoBtn.upBtn.selected?HXUPTYPE:HXDOWTYPE]}];
        self.chooseBlock(_listPhotoArray);
    }
}
- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath{
    [tableView deselectRowAtIndexPath:indexPath animated:YES];
    [_listPhotoArray replaceObjectAtIndex:(_selectedBtn.tag - 300) withObject:@{@"typekey":[NSString stringWithFormat:@"%@",[_numArray objectAtIndex:indexPath.row]],@"phototype":[NSNumber numberWithInteger:HXNONETYPE]}];
    _selectedBtn.titleLabel.text = [_numArray objectAtIndex:indexPath.row];
    _myTableView.hidden = YES;
    
    self.chooseBlock(_listPhotoArray);
}
- (void)getChooseBlock:(returnChooseBlock)block{
    self.chooseBlock = block;
}

- (void)buttonChoose:(UIButton *)button{
    HXPhotoButton *btn = (HXPhotoButton *)button.superview;
    NSLog(@"btn.tag = %ld",btn.tag);
    if (btn.tag == _selectedPhotoBtn.tag) {
        btn.myBtn.selected = YES;
        btn.upBtn.selected = !_selectedPhotoBtn.upBtn.selected;
        btn.downBtn.selected = !_selectedPhotoBtn.downBtn.selected;
        _selectedPhotoBtn = btn;
    }else{
        /*多项选择时，不同按钮点击之后不用恢复上次的点击效果，所以下面四部不需要
         _selectedPhotoBtn.selected = NO;
         _selectedPhotoBtn.myBtn.selected = NO;
         _selectedPhotoBtn.upBtn.selected = NO;
         _selectedPhotoBtn.downBtn.selected = NO;
         */
        _selectedPhotoBtn.selected = NO;
        _selectedPhotoBtn.myBtn.selected = NO;
        _selectedPhotoBtn.upBtn.selected = NO;
        _selectedPhotoBtn.downBtn.selected = NO;
        [_photoDataArray replaceObjectAtIndex:(_selectedPhotoBtn.tag - 200) withObject:@{@"typekey":[NSString stringWithFormat:@"%@",_selectedPhotoBtn.myBtn.titleLabel.text],@"phototype":[NSNumber numberWithInteger:HXNONETYPE]}];

        btn.myBtn.selected = YES;
        if (!btn.upBtn.selected && !btn.downBtn.selected) {
            btn.upBtn.selected = NO;
            btn.downBtn.selected = YES;
        }else{
        btn.upBtn.selected = !btn.upBtn.selected;
        btn.downBtn.selected =!btn.downBtn.selected;
        }
        _selectedPhotoBtn = btn;
    }
    [_photoDataArray replaceObjectAtIndex:(_selectedPhotoBtn.tag - 200) withObject:@{@"typekey":[NSString stringWithFormat:@"%@",btn.myBtn.titleLabel.text],@"phototype":[NSNumber numberWithInteger:btn.upBtn.selected?HXUPTYPE:HXDOWTYPE]}];
    [self.delegate performSelector:@selector(photoSegmentButtonClick:) withObject:_photoDataArray];
}

- (void)chooseSegment:(UIButton *)btn{
    if (btn.tag == _selectedBtn.tag) {
        return;
    }else{
        _selectedBtn.selected = NO;
        btn.selected = YES;
        _selectedBtn = btn;
    }
    [self.delegate performSelector:@selector(SegmentButtonClick:) withObject:_selectedBtn];
}
@end
